unit Unit4;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, IWControl,
  IWHTML5PieChart, IWCompCheckbox, IWCompLabel, Controls, IWVCLBaseControl,
  IWBaseControl, IWBaseHTMLControl, IWCompListbox, IWHTML5Base, Forms,
  IWVCLBaseContainer, IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion;

type
  TIWForm4 = class(TIWAppForm)
    TIWHTML5PieChart1: TTIWHTML5PieChart;
    IWLabel1: TIWLabel;
    IWLabel5: TIWLabel;
    IWLabel6: TIWLabel;
    IWRegion1: TIWRegion;
    IWRegion2: TIWRegion;
    IWLabel10: TIWLabel;
    IWLabel4: TIWLabel;
    IWComboBox4: TIWComboBox;
    IWComboBox1: TIWComboBox;
    IWLabel2: TIWLabel;
    IWLabel3: TIWLabel;
    IWComboBox2: TIWComboBox;
    IWCheckBox1: TIWCheckBox;
    IWCheckBox2: TIWCheckBox;
    IWCheckBox3: TIWCheckBox;
    procedure IWAppFormCreate(Sender: TObject);
    procedure IWComboBox4AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWComboBox1AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWComboBox2AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWCheckBox1AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWCheckBox2AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWCheckBox3AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure IWAppFormRender(Sender: TObject);
    procedure TIWHTML5PieChart1AsyncLegendClick(Sender: TObject;
      EventParams: TStringList; Index: Integer);
    procedure TIWHTML5PieChart1AsyncSegmentClick(Sender: TObject;
      EventParams: TStringList; Index: Integer);
  public
    procedure AddSegments(Count: integer);
    procedure ExplodeSegment(Index: integer);
  end;

implementation

{$R *.dfm}


procedure TIWForm4.AddSegments(Count: integer);
var
  I: integer;
begin

  TIWHTML5PieChart1.Segments.Clear;

  for I := 0 to Count - 1 do
  begin
    with TIWHTML5PieChart1.Segments.Add do
    begin
      Value := Random(100);
      LineColor := clWebWhite;
      LineWidth := 1;
      Text := FloatToStr(Value);
      ShowLabel := IWCheckBox2.Checked;
    end;
  end;
end;

procedure TIWForm4.ExplodeSegment(Index: integer);
var
  I: integer;
begin
    for I := 0 to TIWHTML5PieChart1.Segments.Count - 1 do
    begin
      TIWHTML5PieChart1.Segments[I].State := ssNormal;
    end;

    TIWHTML5PieChart1.Segments[Index].State := ssExploded;

    TIWHTML5PieChart1.AsyncUpdateAllValues(false);
end;

procedure TIWForm4.IWAppFormCreate(Sender: TObject);
begin
  AddSegments(StrToInt(IWComboBox4.Items[IWComboBox4.ItemIndex]));
  TIWHTML5PieChart1.ExplodedOffset := 10;
  TIWHTML5PieChart1.Legend.Caption := 'Sales';
  TIWHTML5PieChart1.BorderWidth := 0;
  TIWHTML5PieChart1.AnimationType := atEndAngle;
  TIWHTML5PieChart1.Legend.Position := lpLeft;
end;

procedure TIWForm4.IWAppFormRender(Sender: TObject);
begin
  // IE
  PageContext.DocType := '<!DOCTYPE html>';
end;

procedure TIWForm4.IWCheckBox1AsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  if IWCheckBox1.Checked then
  begin
    TIWHTML5PieChart1.PieStartAngle := 180;
    TIWHTML5PieChart1.PieEndAngle := 360;
  end
  else
  begin
    TIWHTML5PieChart1.PieStartAngle := 0;
    TIWHTML5PieChart1.PieEndAngle := 360;
  end;

  TIWHTML5PieChart1.AsyncUpdateAllValues(true);
end;

procedure TIWForm4.IWCheckBox2AsyncChange(Sender: TObject;
  EventParams: TStringList);
var
  I: Integer;
begin
  for I := 0 to TIWHTML5PieChart1.Segments.Count - 1 do
    TIWHTML5PieChart1.Segments[I].ShowLabel := IWCheckBox2.Checked;

  TIWHTML5PieChart1.AsyncUpdateAllValues(false);
end;

procedure TIWForm4.IWCheckBox3AsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  TIWHTML5PieChart1.ShowShadow := IWCheckBox3.Checked;
  TIWHTML5PieChart1.AsyncUpdateAllValues(false);
end;

procedure TIWForm4.IWComboBox1AsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  if IWComboBox1.ItemIndex = 0 then
    TIWHTML5PieChart1.Legend.Position := lpNone
  else if IWComboBox1.ItemIndex = 1 then
  begin
    TIWHTML5PieChart1.Legend.Position := lpLeft;
    TIWHTML5PieChart1.Legend.Orientation := oVertical;
  end
  else if IWComboBox1.ItemIndex = 2 then
  begin
    TIWHTML5PieChart1.Legend.Position := lpRight;
    TIWHTML5PieChart1.Legend.Orientation := oVertical;
  end
  else if IWComboBox1.ItemIndex = 3 then
  begin
    TIWHTML5PieChart1.Legend.Position := lpCenter;
    TIWHTML5PieChart1.Legend.Orientation := oHorizontal;
  end
  else if IWComboBox1.ItemIndex = 4 then
  begin
    TIWHTML5PieChart1.Legend.Position := lpAbsolute;
    TIWHTML5PieChart1.Legend.Orientation := oVertical;
  end;

  TIWHTML5PieChart1.AsyncUpdateAllValues(true);
end;

procedure TIWForm4.IWComboBox2AsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  if IWComboBox2.ItemIndex = 0 then
    TIWHTML5PieChart1.AnimationType := atNone
  else if IWComboBox2.ItemIndex = 1 then
    TIWHTML5PieChart1.AnimationType := atEndAngle
  else if IWComboBox2.ItemIndex = 2 then
    TIWHTML5PieChart1.AnimationType := atRadius;

  TIWHTML5PieChart1.AsyncUpdateAllValues(true);
end;

procedure TIWForm4.IWComboBox4AsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  AddSegments(StrToInt(IWComboBox4.Items[IWComboBox4.ItemIndex]));
  TIWHTML5PieChart1.AsyncUpdateAllValues(true);
end;

procedure TIWForm4.TIWHTML5PieChart1AsyncSegmentClick(Sender: TObject;
  EventParams: TStringList; Index: Integer);
begin
  ExplodeSegment(Index);
end;

procedure TIWForm4.TIWHTML5PieChart1AsyncLegendClick(Sender: TObject;
  EventParams: TStringList; Index: Integer);
begin
  ExplodeSegment(Index);
end;

initialization
  TIWForm4.SetAsMainForm;

end.
